SystemOrganization addCategory: #'Magritte-Tutorial-Model'!
SystemOrganization addCategory: #'Magritte-Tutorial-View'!

Object subclass: #MAAddressModel
	instanceVariableNames: 'street plz place canton nationality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-Model'!

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 1/4/2006 15:34'!
descriptionCanton
	^ (MASingleOptionDescription auto: 'canton' label: 'Canton' priority: 40)
		options: #( 'Zurich' 'Bern' 'Luzern' 'Uri' 'Schwyz' 'Unterwalden' 'Glarus' 'Zug' 'Freiburg' 'Solothurn' 'Basel' 'Schaffhausen' 'Appenzell' 'St. Gallen' 'Graubunden' 'Aargau' 'Thurgau' 'Ticino' 'Vaud' 'Valais' 'Neuchatel' 'Geneve' 'Jura' );
		reference: MAStringDescription new;
		beSorted;
		yourself.! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 19:58'!
descriptionPlace
	^ MAStringDescription auto: 'place' label: 'Place' priority: 30.! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 21:31'!
descriptionPlz
	^ (MANumberDescription auto: 'plz' label: 'PLZ' priority: 20)
		min: 1000 max: 9999;
		yourself.! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 19:57'!
descriptionStreet
	^ MAStringDescription auto: 'street' label: 'Street' priority: 10.! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
canton
	^ canton! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:53'!
canton: anObject
	canton := anObject! !

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 11/14/2005 21:51'!
hash
	^ self street hash bitXor: self place hash.! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
nationality
	^ nationality! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:53'!
nationality: anObject
	nationality := anObject! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
place
	^ place! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:53'!
place: anObject
	place := anObject! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
plz
	^ plz! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:53'!
plz: anObject
	plz := anObject! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
street
	^ street! !

!MAAddressModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:53'!
street: anObject
	street := anObject! !

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 10/19/2005 21:21'!
= anObject
	^ self species = anObject species
		and: [ self street = anObject street
		and: [ self plz = anObject plz
		and: [ self place = anObject place
		and: [ self canton = anObject canton ] ] ] ].! !

Object subclass: #MAPersonModel
	instanceVariableNames: 'title firstName lastName email homeAddress officeAddress picture birthday phones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-Model'!

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 1/13/2006 14:47'!
descriptionAge
	^ (MANumberDescription selector: #age label: 'Age' priority: 80)
		beReadonly;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 1/13/2006 14:47'!
descriptionBirthday
	^ MADateDescription auto: 'birthday' label: 'Birthday' priority: 70.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:25'!
descriptionFirstName
	^ (MAStringDescription auto: 'firstName' label: 'First Name' priority: 20)
		beRequired;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'dc 2/1/2006 10:40'!
descriptionHomeAddress
	^ (MAToOneRelationDescription auto: 'homeAddress' label: 'Home Address' priority: 40)
		componentClass: MAInternalEditorComponent;
		classes: (Array with: MAAddressModel);
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 20:26'!
descriptionLastName
	^ (MAStringDescription auto: 'lastName' label: 'Last Name' priority: 30)
		beRequired;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'dc 2/1/2006 10:40'!
descriptionOfficeAddress
	^ (MAToOneRelationDescription auto: 'officeAddress' label: 'Office Address' priority: 50)
		componentClass: MAExternalEditorComponent;
		classes: (Array with: MAAddressModel);
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'dc 2/1/2006 10:39'!
descriptionPhoneNumbers
	^ (MAToManyRelationDescription auto: 'phones' label: 'Phone Numbers' priority: 90)
		classes: (Array with: MAPhoneModel);
		default: Array new;
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 1/13/2006 14:47'!
descriptionPicture
	^ (MAFileDescription auto: 'picture' label: 'Picture' priority: 60)
		addCondition: [ :value | value isImage ] labelled: 'Image expected';
		yourself.! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 10/19/2005 21:04'!
descriptionTitle
	^ (MASingleOptionDescription auto: 'title' label: 'Title' priority: 10)
		options: #( 'Mr.' 'Mrs.' 'Ms.' 'Miss.' );
		yourself.! !

!MAPersonModel methodsFor: 'accessing-calculated' stamp: 'lr 10/19/2005 00:05'!
age
	^ self birthday notNil
		ifTrue: [ Date current year - self birthday year ].! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
birthday
	^ birthday! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
birthday: anObject
	birthday := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
email
	^ email! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
email: anObject
	email := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:49'!
firstName
	^ firstName! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
firstName: anObject
	firstName := anObject! !

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 11/14/2005 21:51'!
hash
	^ self firstName hash bitXor: self lastName hash.! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
homeAddress
	^ homeAddress! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
homeAddress: anObject
	homeAddress := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
lastName
	^ lastName! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
lastName: anObject
	lastName := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
officeAddress
	^ officeAddress! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
officeAddress: anObject
	officeAddress := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
phones
	^ phones! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
phones: anObject
	phones := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:50'!
picture
	^ picture! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
picture: anObject
	picture := anObject! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:49'!
title
	^ title! !

!MAPersonModel methodsFor: 'accessing-generated' stamp: 'lr 1/13/2006 18:52'!
title: anObject
	title := anObject! !

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 11/20/2005 23:18'!
= anObject
	^ self species = anObject species
		and: [ self title = anObject title
		and: [ self firstName = anObject firstName
		and: [ self lastName = anObject lastName
		and: [ self picture = anObject picture
		and: [ self birthday = anObject birthday
		and: [ self officeAddress = anObject officeAddress
		and: [ self homeAddress = anObject homeAddress ] ] ] ] ] ] ].! !

Object subclass: #MAPhoneModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-Model'!

!MAPhoneModel class methodsFor: 'accessing-description' stamp: 'lr 11/3/2005 18:06'!
descriptionKind
	^ MAStringDescription auto: 'kind' label: 'Kind' priority: 10.! !

!MAPhoneModel class methodsFor: 'accessing-description' stamp: 'lr 11/3/2005 18:05'!
descriptionNumber
	^ MAStringDescription auto: 'number' label: 'Number' priority: 20.! !

!MAPhoneModel methodsFor: 'comparing' stamp: 'lr 11/14/2005 21:52'!
hash
	^ self kind hash bitXor: self number hash.! !

!MAPhoneModel methodsFor: 'comparing' stamp: 'lr 11/14/2005 21:52'!
= anObject
	^ self species = anObject species
		and: [ self kind = anObject kind
		and: [ self number = anObject number ] ].! !

WAComponent subclass: #MAPersonEditor
	instanceVariableNames: 'person component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-View'!

!MAPersonEditor class methodsFor: 'initialize' stamp: 'lr 1/13/2006 15:19'!
initialize
	self registerAsApplication: 'personeditor'.! !

!MAPersonEditor methodsFor: 'private' stamp: 'lr 1/13/2006 15:19'!
buildComponent
	^ self person asComponent 
		addValidatedForm;
		yourself.! !

!MAPersonEditor methodsFor: 'accessing-dynamic' stamp: 'lr 1/13/2006 15:15'!
children
	^ Array with: self component.! !

!MAPersonEditor methodsFor: 'accessing-dynamic' stamp: 'lr 1/13/2006 15:16'!
component
	^ component ifNil: [ component := self buildComponent ].! !

!MAPersonEditor methodsFor: 'accessing' stamp: 'lr 1/13/2006 15:17'!
person
	^ person ifNil: [ person := MAPersonModel new ].! !

!MAPersonEditor methodsFor: 'rendering' stamp: 'lr 1/13/2006 15:17'!
renderContentOn: html
	html heading: 'Edit Person'.
	html render: self component.! !
MAPersonEditor initialize!
